// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package apis

type AccessLogWrite struct {
	State             bool    `json:"state"`
	Code              int     `json:"code"`      //  原始错误码，非输出
	RespCode          int     `json:"resp_code"` // 输出错误码
	Msg               string  `json:"msg"`
	RawRequestParams  string  `json:"raw_request_params"`
	RawResponseParams string  `json:"raw_response_params"`
	RequestParams     string  `json:"request_params"`
	ResponseParams    string  `json:"response_params"`
	IsReuse           bool    `json:"is_reuse"`
	UtSource          string  `json:"ut_source"`
	Elapsed           float64 `json:"elapsed"`
	Search            string  `json:"search"`
	OrderNo           string  `json:"order_no"`
}

type ThirdpartLogWrite struct {
	ProviderApiId  int64   `json:"provider_api_id"`
	RequestParams  string  `json:"request_params"`
	ResponseParams string  `json:"response_params"`
	RawCode        string  `json:"raw_code"`
	Code           int     `json:"code"`
	Msg            string  `json:"msg"`
	State          bool    `json:"state"`
	Elapsed        float64 `json:"elapsed"`
	ProviderCode   string  `json:"provider_code"`
	Search         string  `json:"search"`
	Timestamp      int64   `json:"timestamp"`
}

type LogAddAccessLogReq struct {
	AccessLogWrite
	MerchantId         int64               `json:"merchant_id"`
	ApiId              int64               `json:"api_id"`
	RemoteAddr         string              `json:"remote_addr"`
	TimeStamp          int64               `json:"time_stamp"`
	ThirdpartLogWrites []ThirdpartLogWrite `json:"thirdpart_log_writes"`
	MerchantChildApiId int64               `json:"merchant_child_api_id"`
	MerchantDataApiId  int64               `json:"merchant_data_api_id"`
	ReplaceInfo        MerchantReplaceInfo `json:"merchant_replace_info"`
}

type LogAddAccessLogReply struct {
}

type LogAddInvalidAccessLogReq struct {
	MerchantId    int64   `json:"merchant_id"`
	ApiId         int64   `json:"api_id"`
	RemoteAddr    string  `json:"remote_addr"`
	TimeStamp     int64   `json:"time_stamp"`
	Code          int     `json:"code"`
	Msg           string  `json:"msg"`
	RequestParams string  `json:"request_params"`
	Elapsed       float64 `json:"elapsed"`
}

type LogAddInvalidAccessLogReply struct {
}
