package apis

type MerchantApiInfo struct {
	MerchantChildApiId int64  `json:"merchant_child_api_id"`
	IsForceUpdate      bool   `json:"is_force_update"`
	ReuseTime          int    `json:"reuse_time"`
	MerchantId         int64  `json:"merchant_id"`
	BaseApiId          int64  `json:"base_api_id"`
	RandomPercentage   int    `json:"random_percentage"`
	ApiTimeout         uint64 `json:"api_timeout" description:"商户接口超时时间"`
	ResponseParamConf    []ManagementBaseApiParam `json:"response_param_conf" description:"响应参数"`
}

type CommonReq struct {
	Data interface{} `json:"data"`
	Code string      `json:"code"`
	MerchantApiInfo
}

type CommonReply struct {
	Data    interface{}         `json:"data"`
	IsReuse bool                `json:"is_reuse"`
	LReq    []ThirdpartLogWrite `json:"l_req"`
	ErrCode int                 `json:"err_code"`
	ErrMsg  string              `json:"err_msg"`
}
