package param_v1_0

import "gd_gateway/params/param_base"

type BodyData struct {
	Data string `json:"data"`
}
type ParamBody struct {
	AppKey        string   `json:"app_key" description:"app key" required:"true" in:"header"`
	Ts            string   `json:"ts" description:"时间戳" required:"true" in:"header"`
	ReplaceAppKey string   `json:"replace_app_key" in:"header"`
	Sign          string   `json:"sign" description:"签名" required:"true" in:"header"`
	IsSign        string   `json:"is_sign" description:"是否签名" required:"false" in:"header"`
	Data          BodyData `json:"data" description:"数据" required:"true" in:"body"`
}

type ParamQuery struct {
	Appkey        string `json:"appkey" description:"app key" required:"false" in:"header"`
	Token         string `json:"token" description:"token" required:"false" in:"header"`
	Sign          string   `json:"sign" description:"签名" required:"false" in:"header"`
	Timestamp     string   `json:"timestamp" description:"时间戳" required:"false" in:"header"`
	ReplaceAppKey string `json:"replace_app_key" description:"replace_app_key" required:"false" in:"header"`
	Data          string `json:"data" description:"数据" required:"false" in:"header"`
	EncryptType   string `json:"encrypt_type" description:"加密类型" required:"false" in:"header"`
}

type ParamQueryPath struct {
	AppKey        string `json:"app_key" description:"app key" required:"true" in:"header"`
	Ts            string `json:"ts" description:"时间戳" required:"true" in:"header"`
	Sign          string `json:"sign" description:"签名" required:"true" in:"header"`
	IsSign        string `json:"is_sign" description:"是否签名" required:"false" in:"header"`
	Data          string `json:"data" description:"数据" required:"true" in:"query"`
	Path          string `json:"path" in:"path" require:"true"`
	ReplaceAppKey string `json:"replace_app_key" in:"header"`
}

type CommonResponse struct {
	param_base.SimpleResp
	Data    interface{} `json:"data" description:"数据"`
	OrderNo string      `json:"order_no,omitempty"`
}

type VehicleLoginRequest struct {
	User     string `json:"user" description:"用户名" in:"query"`
	Password string `json:"password" description:"密码" in:"query"`
}

type VehicleLoginResponse struct {
	param_base.SimpleResp
	Token string `json:"token" description:"token"`
	Expire int64 `json:"expire"`
}
