package vehicle

import (
	"bytes"
	"encoding/hex"
	"encoding/json"
	"fmt"
	"gd_gateway/common.in/config"
	"gd_gateway/common.in/utils"
	"io/ioutil"
	"net/http"
	"sort"
	"strings"
	"time"
)

const (
	/*APPKEY = "c1e7371a206d945c1feafa030bd311e7"
	APPSEC = "84674eeb8b87256cbbcfeb6b1fcac0f8"
	HOST   = "http://114.116.149.44:61001"
	*/
	APPKEY = "3ea7b0342978a755d9dae59df3d2da73"
	APPSEC = "69ab72e26e8c374fd82699306e4c9a0e"
	//HOST   = "http://devapi.gd.com"
	HOST   = "http://47.99.122.104:41002"
	TOKEN = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1aWQiOjMsInVzZXJfbmFtZSI6IjhkYWFmMGIzZTA0NjY2MzljNDJhNzE2MjA2ODQ3YThmIiwiZXhwIjoxNjc5NDY1NDI0LCJpYXQiOjE2Nzk0NjU0MDQsIm5iZiI6MTY3OTQ2NTQwNCwic3ViIjoiMyJ9.xuETqX8gPwL7roDx135OLzBLR3Kjar7ukVs7mKZb3TQ"
)

func concatGetURL(url string, data map[string]string) string {
	if data == nil {
		return url
	}

	for k, v := range data {
		url = url + "&" + k + "=" + v
	}

	url = strings.Replace(url, "&", "?", 1)
	return url
}

func GdClientPost(api string, data map[string]interface{}) (result []byte, err error) {
	jsonData, err := json.Marshal(data)
	if err != nil {
		return nil, err
	}
	var realData = map[string]string{
		"data": string(jsonData),
	}
	jsonData, err = json.Marshal(realData)
	if err != nil {
		return nil, err
	}

	client := &http.Client{}
	client.Timeout = 1000 * time.Second
	req, err := http.NewRequest("POST", api, bytes.NewBuffer(jsonData))
	if err != nil {
		return nil, err
	}

	timestamp := "1111"

	req.Header.Set("app_key", APPKEY)
	req.Header.Set("ts", timestamp)
	signtext := fmt.Sprintf("%s%s%s%s", timestamp, string(jsonData), APPKEY, APPSEC)
	req.Header.Set("sign", utils.MD5(signtext))
	req.Header.Set("Content-Type", "application/json")

	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	result, err = ioutil.ReadAll(resp.Body)
	return
}


func GdClientGet(api string, reqParam map[string]string) (result []byte, err error) {

	client := &http.Client{}
	client.Timeout = 1000 * time.Second
	req, err := http.NewRequest("GET", concatGetURL(api, reqParam), nil)
	if err != nil {
		return nil, err
	}

	var keyList []string
	for k,_ := range reqParam{
		keyList = append(keyList,k)
	}
	sort.Strings(keyList)
	signParam := ""
	for _,v := range keyList{
		signParam = signParam + v+reqParam[v]
	}

	timestamp := "1680256519"
	req.Header.Set("appkey", APPKEY)
	req.Header.Set("timestamp", timestamp)
	signtext := fmt.Sprintf("%s%s%s%s",APPKEY, APPSEC, timestamp, signParam)
	req.Header.Set("sign", utils.MD5(signtext))
	req.Header.Set("Content-Type", "application/json")
	fmt.Println("SSSSSSSSSSSSSSSSSSSSS:", utils.MD5(signtext))
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	fmt.Println("http state:", resp.StatusCode, resp.Status)
	defer resp.Body.Close()

	result, err = ioutil.ReadAll(resp.Body)
	fmt.Println(string(result), " error: ", err)
	return
}

func GdClientCryptoGet(api string, data map[string]string) (result []byte, err error) {
	for k,v := range data{

		bytes, _ := config.AesEncrypt(v, APPSEC)
		ret := hex.EncodeToString(bytes)
		data[k] = ret
	}
	fmt.Println("data:",data)
	client := &http.Client{}
	client.Timeout = 1000 * time.Second
	req, err := http.NewRequest("GET", concatGetURL(api, data), nil)
	if err != nil {
		return nil, err
	}

	var keyList []string
	for k,_ := range data{
		keyList = append(keyList,k)
	}

	sort.Strings(keyList)
	fmt.Println("keylist :",keyList)
	signParam := ""
	for _,v := range keyList{
		signParam = signParam + v+data[v]
	}
	fmt.Println("signParam:",signParam)
	timestamp := "1111"
	//req.Header.Set("token", TOKEN)
	req.Header.Set("appkey", APPKEY)
	req.Header.Set("timestamp", timestamp)
	signtext := fmt.Sprintf("%s%s%s%s",APPKEY, APPSEC, timestamp, signParam)
	req.Header.Set("sign", utils.MD5(signtext))
	req.Header.Set("encrypt_type", "AES")
	req.Header.Set("Content-Type", "application/json")

	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	fmt.Println("http state:", resp.StatusCode, resp.Status)
	defer resp.Body.Close()

	result, err = ioutil.ReadAll(resp.Body)
	fmt.Println(string(result), " error: ", err)
	return
}
